// ConsoleApplication120.cpp : Defines the entry point for the console application.
//

// ConsoleApplication111.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include<iostream>
#include<cmath>
#include"time.h"
#include<clocale>

using namespace std;

const double k = 1.38*pow(10, -23);// 
const double Na = 6.02*pow(10, 23);// 
const double pi = 3.1415926535897;


struct Vektor
{
	double x;//    OX, OY, OZ
	double y;
	double z;
};
int buffer;// 
double t = 0, dt = 0.01;//  ;
int nn, m=1;//     ;
double dlr;
double a;
double b;
double c;///a,b,c -  ,   .
double v;//   
double P = 0, P1 = 0, P2 = 0, P3 = 0;//    , P - 
double T;// 

class Perfektgas
{
private:

	Vektor *v1;//    
	Vektor *v2;//-//-//-/-/-/-/ 
	Vektor *r1;// -   
	Vektor *r2;//-//-//-/-/-/-/ 


public:
	Vektor dr/*  */, e;/* */
		void Print();//  
	void VNK();//    
	void RVK();//    
	void RNK();// -    
	void Push();//   
	void Temp();//  
	void Hit();//   
	void DEL();// 
};

ostream & operator<< (ostream &os, const Perfektgas &ob)
{
	cout << ob;
	return os;
}
istream & operator >> (istream &os, const Perfektgas &ob)
{
	cin >> ob;
	return os;
}
void Perfektgas::Print()
{
	v1 = new Vektor[buffer];
	v2 = new Vektor[buffer];
	r1 = new Vektor[buffer];
	r2 = new Vektor[buffer];

}


void Perfektgas::RVK()
{

	srand(time(0));

	for (int i = 0; i < buffer; i++)
	{
		v1[i].x = rand() % 10 + 1;
		v1[i].y = rand() % 10 + 1;
		v1[i].z = rand() % 10 + 2;
		r1[i].x = rand() % 5 + 1;
		r1[i].y = rand() % 5 + 1;
		r1[i].z = rand() % 5 + 2;


	}



}
void Perfektgas::VNK()
{


	for (int i = 0; i < buffer; i++)
	{

		v2[i].x = v1[i].x;
		v2[i].y = v1[i].y;
		v2[i].z = v1[i].z;

		for (int j = i + 1; j < buffer; j++)
		{
			dr.x = r1[j].x - r1[i].x;
			dr.y = r1[j].y - r1[i].y;
			dr.z = r1[j].z - r1[i].z;
			if ((dr.x != 0) || (dr.y != dr.x) || (dr.z != dr.y) || (dr.z != dr.x))

			{
				dlr = sqrt(dr.x*dr.x + dr.y*dr.y + dr.z*dr.z);
				e.x = dr.x / dlr;
				e.y = dr.y / dlr;
				e.z = dr.z / dlr;
			}
			Vektor vpi, vpj;/*    */
			double vix = v1[i].x*e.x;
			double viy = v1[i].y*e.y;
			double viz = v1[i].z*e.z;
			double vjx = v1[j].x*e.x;
			double vjy = v1[j].y*e.y;
			double vjz = v1[j].z*e.z;
			vpi.x = v1[i].x - vix*e.x;
			vpi.y = v1[i].y - viy*e.y;
			vpi.z = v1[i].z - viz*e.z;
			vpj.x = v1[j].x - vjx*e.x;
			vpj.y = v1[j].y - vjy*e.y;
			vpj.z = v1[j].z - vjz*e.z;
			v2[i].x = vpi.x + vjx*e.x;
			v2[i].y = vpi.y + vjy*e.y;
			v2[i].z = vpi.z + vjz*e.z;
			v2[j].x = vpj.x + vix*e.x;
			v2[j].y = vpj.y + viy*e.y;
			v2[j].z = vpj.z + viz*e.z;


		}


		v = sqrt(v2[i].x*v2[i].x + v2[i].y*v2[i].y + v2[i].z*v2[i].z);
		//        

	}

}

void Perfektgas::RNK()
{
	for (int i = 0; i < buffer; i++)
	{
		t += dt;
		r2[i].x = v2[i].x*t;
		r2[i].y = v2[i].y*t;
		r2[i].z = v2[i].z*t;//    


	}


}

void Perfektgas::Push()
{

	for (int i = 0; i < buffer; i++)
	{
		t += dt;
		if ((r2[i].x < 0.01*a) && (r2[i].y < 0.01*b) && (r2[i].z < 0.01*c))//    


			P1 += 2 * m*buffer*v2[i].x / t / (b*c); //    ,   
		P2 += 2 * m*buffer*v2[i].y / t / (a*c);
		P3 += 2 * m*buffer*v2[i].z / t / (a*b);
	}

	P = P1 + P2 + P3;

}
void Perfektgas::Temp()
{
	T = P*a*b*c / (buffer*Na*k);//   -


}

void Perfektgas::Hit()
{

	nn = v*pow(buffer, 1.5) / (4 * sqrt(2)*a*b*c);
	//nn = 0.25*n*<v>,       
}


void Perfektgas::DEL()
{
	delete[]v1;
	delete[]v2;
	delete[]r1;
	delete[]r2;
}
int main()
{

	setlocale(LC_ALL, "Russian");
	Perfektgas N;
	cout << "      \n";
	cin >> buffer;
	N.Print();
	N.RVK();
	N.VNK();
	N.RNK();
	cout << "  \n";
	cin >> a;
	cin >> b;
	cin >> c;

	N.Push();
	cout << " :" << " " << P << "\n";
	N.Temp();
	cout << "T :" << " " << T << "\n";
	N.Hit();
	cout << "     :" << " " << nn << "\n";
	N.DEL();
	system("pause");
	return 0;
}

